package com.ejie.ab79.dao.preguntasRespuestas;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.REST.servicioWeb.RespuestaProtocolo;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.ab79.model.preguntasRespuestas.PreguntasProtocolo;
import com.ejie.ab79.model.preguntasRespuestas.RelProPre;
import com.ejie.ab79.model.preguntasRespuestas.RespuestasProtocolo;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RespuestasProtocoloDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class RespuestasProtocoloDaoImpl implements RespuestasProtocoloDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRESPUESTAPROTOCOLO", "IDRELPROPRE",
			"IDINSPECCION", "RESPUESTA", "FECHAREGISTRO", "USUARIOREGISTRO", "FECHAULTMODIFICACION",
			"USUARIOULTMODIFICACION" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<RespuestasProtocolo> rwMap = new RowMapper<RespuestasProtocolo>() {
		public RespuestasProtocolo mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));
			return new RespuestasProtocolo(resultSet.getInt("IDRESPUESTAPROTOCOLO"), resultSet.getInt("IDRELPROPRE"),
					inspeccion, resultSet.getString("RESPUESTA"), resultSet.getDate("FECHAREGISTRO"),
					resultSet.getString("USUARIOREGISTRO"), resultSet.getDate("FECHAULTMODIFICACION"),
					resultSet.getString("USUARIOULTMODIFICACION"));
		}
	};

	private RowMapper<RespuestasProtocolo> rwMapPK = new RowMapper<RespuestasProtocolo>() {
		public RespuestasProtocolo mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RespuestasProtocolo(resultSet.getInt("IDRESPUESTAPROTOCOLO"));
		}
	};

	private RowMapper<RelProPre> rwMapRelProPrePK = new RowMapper<RelProPre>() {
		public RelProPre mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new RelProPre(resultSet.getInt("IDRELPROPRE"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<RespuestasProtocolo>> rwMapJerarquia = new RowMapper<JerarquiaDto<RespuestasProtocolo>>() {
		public JerarquiaDto<RespuestasProtocolo> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Inspecciones inspeccion = new Inspecciones();
			inspeccion.setIdInspeccion(resultSet.getInt("IDINSPECCION"));

			RespuestasProtocolo respuestasprotocolo = new RespuestasProtocolo(resultSet.getInt("IDRESPUESTAPROTOCOLO"),
					resultSet.getInt("IDRELPROPRE"), inspeccion, resultSet.getString("RESPUESTA"),
					resultSet.getDate("FECHAREGISTRO"), resultSet.getString("USUARIOREGISTRO"),
					resultSet.getDate("FECHAULTMODIFICACION"), resultSet.getString("USUARIOULTMODIFICACION"));

			JerarquiaDto<RespuestasProtocolo> jerarquia = new JerarquiaDto<RespuestasProtocolo>();
			jerarquia.setModel(respuestasprotocolo);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<RespuestaProtocolo> rwMapRespuestaProtocoloREST = new RowMapper<RespuestaProtocolo>() {
		public RespuestaProtocolo mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			RespuestaProtocolo respuestaProtocolo = new RespuestaProtocolo();
			respuestaProtocolo.setIdPreguntaProtocolo(resultSet.getInt("idpreguntaprotocolo"));
			respuestaProtocolo.setRespuesta(resultSet.getString("respuesta"));
			respuestaProtocolo.setIdRelacionProtocoloPregunta(resultSet.getInt("idrelpropre"));
			return respuestaProtocolo;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the RespuestasProtocolo table.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @return RespuestasProtocolo
	 */
	public RespuestasProtocolo add(RespuestasProtocolo respuestasprotocolo) {

		int idRespuestaProtocolo = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7912T00.NEXTVAL FROM DUAL",
				Integer.class);

		String query = "INSERT INTO RESPUESTAS_PROTOCOLO (ID_RESPUESTA_PROTOCOLO, ID_REL_PRO_PRE, ID_INSPECCION, RESPUESTA, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,sysdate,?)";
		this.jdbcTemplate.update(query, idRespuestaProtocolo,
				respuestasprotocolo.getIdRelProPre(), respuestasprotocolo.getInspeccion() != null
						? respuestasprotocolo.getInspeccion().getIdInspeccion() : null,
				respuestasprotocolo.getRespuesta(), respuestasprotocolo.getUsuarioRegistro());

		respuestasprotocolo.setIdRespuestaProtocolo(idRespuestaProtocolo);

		return respuestasprotocolo;
	}

	/**
	 * Updates a single row in the RespuestasProtocolo table.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @return RespuestasProtocolo
	 */
	public RespuestasProtocolo update(RespuestasProtocolo respuestasprotocolo) {
		String query = "UPDATE RESPUESTAS_PROTOCOLO SET ID_REL_PRO_PRE=?, ID_INSPECCION=?, RESPUESTA=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_RESPUESTA_PROTOCOLO=?";
		this.jdbcTemplate.update(query, respuestasprotocolo.getIdRelProPre(),
				respuestasprotocolo.getInspeccion() != null ? respuestasprotocolo.getInspeccion().getIdInspeccion()
						: null,
				respuestasprotocolo.getRespuesta(), respuestasprotocolo.getUsuarioUltmodificacion(),
				respuestasprotocolo.getIdRespuestaProtocolo());
		return respuestasprotocolo;
	}

	public RespuestasProtocolo update_respuesta(RespuestasProtocolo respuestasprotocolo) {
		String query = "UPDATE RESPUESTAS_PROTOCOLO SET RESPUESTA=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_REL_PRO_PRE=?";
		this.jdbcTemplate.update(query, respuestasprotocolo.getRespuesta(),
				respuestasprotocolo.getUsuarioUltmodificacion(), respuestasprotocolo.getIdRelProPre());
		return respuestasprotocolo;
	}

	/**
	 * Finds a single row in the RespuestasProtocolo table.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @return RespuestasProtocolo
	 */
	@Transactional(readOnly = true)
	public RespuestasProtocolo find(RespuestasProtocolo respuestasprotocolo) {
		String query = "SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.ID_REL_PRO_PRE IDRELPROPRE, t1.ID_INSPECCION IDINSPECCION, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM RESPUESTAS_PROTOCOLO t1  WHERE t1.ID_RESPUESTA_PROTOCOLO = ?  ";

		List<RespuestasProtocolo> respuestasprotocoloList = this.jdbcTemplate.query(query, this.rwMap,
				respuestasprotocolo.getIdRespuestaProtocolo());
		return (RespuestasProtocolo) DataAccessUtils.uniqueResult(respuestasprotocoloList);
	}

	@Override
	public RespuestasProtocolo findByIdRelProPreInspeccion(RespuestasProtocolo respuestasProtocolo) {
		String query = "SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.ID_REL_PRO_PRE IDRELPROPRE, t1.ID_INSPECCION IDINSPECCION, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM RESPUESTAS_PROTOCOLO t1  WHERE t1.ID_REL_PRO_PRE = ? AND t1.ID_INSPECCION = ? ";

		List<RespuestasProtocolo> respuestasprotocoloList = this.jdbcTemplate.query(query, this.rwMap,
				respuestasProtocolo.getIdRelProPre(), respuestasProtocolo.getInspeccion() != null
						? respuestasProtocolo.getInspeccion().getIdInspeccion() : null);
		return (RespuestasProtocolo) DataAccessUtils.uniqueResult(respuestasprotocoloList);
	}

	/**
	 * Removes a single row in the RespuestasProtocolo table.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @return
	 */
	public void remove(RespuestasProtocolo respuestasprotocolo) {
		String query = "DELETE FROM RESPUESTAS_PROTOCOLO WHERE ID_RESPUESTA_PROTOCOLO=?";
		this.jdbcTemplate.update(query, respuestasprotocolo.getIdRespuestaProtocolo());
	}

	/**
	 * 
	 */
	@Override
	public void deleteByInspeccion(Integer idInspeccion) {
		String query = "DELETE FROM RESPUESTAS_PROTOCOLO WHERE ID_INSPECCION=?";
		this.jdbcTemplate.update(query, idInspeccion);
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<RespuestasProtocolo> getMultiple(RespuestasProtocolo filterRespuestasProtocolo,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterRespuestasProtocolo, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, RespuestasProtocolo.class,
				params, "ID_RESPUESTA_PROTOCOLO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<RespuestasProtocolo> findByInspeccion(Inspecciones inspeccion) {
		String query = "SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.ID_REL_PRO_PRE IDRELPROPRE, t1.ID_INSPECCION IDINSPECCION, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM RESPUESTAS_PROTOCOLO t1  WHERE t1.ID_INSPECCION = ?  ";

		return (List<RespuestasProtocolo>) this.jdbcTemplate.query(query, this.rwMap, inspeccion.getIdInspeccion());
	}

	public RespuestasProtocolo findByInspeccionYPregunta(Inspecciones inspeccion,
			PreguntasProtocolo preguntaProtocolo) {
		String query = "SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO, t1.ID_REL_PRO_PRE IDRELPROPRE, t1.ID_INSPECCION IDINSPECCION, t1.RESPUESTA RESPUESTA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM RESPUESTAS_PROTOCOLO t1, REL_PRO_PRE t2, PREGUNTAS_PROTOCOLO t3 WHERE t1.ID_REL_PRO_PRE = t2.ID_REL_PRO_PRE AND t1.ID_INSPECCION = ? AND t2.ID_PREGUNTA_PROTOCOLO = t3.ID_PREGUNTA_PROTOCOLO AND t3.ID_PREGUNTA_PROTOCOLO = ?";

		List<RespuestasProtocolo> respuestasprotocoloList = this.jdbcTemplate.query(query, this.rwMap,
				inspeccion.getIdInspeccion(), preguntaProtocolo.getIdPreguntaProtocolo());
		return (RespuestasProtocolo) DataAccessUtils.uniqueResult(respuestasprotocoloList);
	}

	@Override
	public RelProPre findRelProPre(Inspecciones inspeccion, RespuestaProtocolo respuestaProtocolo) {
		String query = "SELECT t1.ID_REL_PRO_PRE IDRELPROPRE FROM REL_PRO_PRE t1, INSPECCIONES t2, PROTOCOLOS t3, PREGUNTAS_PROTOCOLO t4 WHERE t2.ID_INSPECCION = ? AND t2.ID_PROTOCOLO = t3.ID_PROTOCOLO AND t3.ID_PROTOCOLO = t1.ID_PROTOCOLO AND t4.ID_PREGUNTA_PROTOCOLO = t1.ID_PREGUNTA_PROTOCOLO AND t4.ID_PREGUNTA_PROTOCOLO = ?";

		List<RelProPre> relProPreList = this.jdbcTemplate.query(query, this.rwMapRelProPrePK,
				inspeccion.getIdInspeccion(), respuestaProtocolo.getIdPreguntaProtocolo());
		return (RelProPre) DataAccessUtils.uniqueResult(relProPreList);
	}

	/**
	 * Finds a list of rows in the RespuestasProtocolo table.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<RespuestasProtocolo>
	 */
	@Transactional(readOnly = true)
	public List<RespuestasProtocolo> findAll(RespuestasProtocolo respuestasprotocolo, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.ID_REL_PRO_PRE IDRELPROPRE,t1.ID_INSPECCION IDINSPECCION,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM RESPUESTAS_PROTOCOLO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(respuestasprotocolo);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					RespuestasProtocoloDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RespuestasProtocolo>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the RespuestasProtocolo table using like.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<RespuestasProtocolo>
	 */
	@Transactional(readOnly = true)
	public List<RespuestasProtocolo> findAllLike(RespuestasProtocolo respuestasprotocolo,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_INSPECCION IDINSPECCION,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		query.append("FROM RESPUESTAS_PROTOCOLO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(respuestasprotocolo, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					RespuestasProtocoloDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<RespuestasProtocolo>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<RespuestaProtocolo> findRespuestasProtocoloREST(Integer idInspeccion) {
		String query = "SELECT t2.id_pregunta_protocolo idpreguntaprotocolo, t1.respuesta respuesta, t2.id_rel_pro_pre idrelpropre FROM respuestas_protocolo t1, rel_pro_pre t2 WHERE t1.id_inspeccion = ? AND t1.id_rel_pro_pre = t2.id_rel_pro_pre";

		return (List<RespuestaProtocolo>) this.jdbcTemplate.query(query, this.rwMapRespuestaProtocoloREST,
				idInspeccion);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the RespuestasProtocolo table.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(RespuestasProtocolo respuestasprotocolo) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM RESPUESTAS_PROTOCOLO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(respuestasprotocolo);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the RespuestasProtocolo table using like.
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(RespuestasProtocolo respuestasprotocolo, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM RESPUESTAS_PROTOCOLO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(respuestasprotocolo, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of RespuestasProtocolo selected for rup_table
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RespuestasProtocolo>>
	 */
	@Override
	public List<TableRowDto<RespuestasProtocolo>> reorderSelection(RespuestasProtocolo respuestasprotocolo,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_INSPECCION IDINSPECCION,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM RESPUESTAS_PROTOCOLO t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(respuestasprotocolo, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				RespuestasProtocolo.class, filterParamList, "ID_RESPUESTA_PROTOCOLO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RespuestasProtocolo>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            RespuestasProtocolo
	 * @param searchParams
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<RespuestasProtocolo>>
	 */
	@Override
	public List<TableRowDto<RespuestasProtocolo>> search(RespuestasProtocolo filterParams,
			RespuestasProtocolo searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_INSPECCION IDINSPECCION,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM RESPUESTAS_PROTOCOLO t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				RespuestasProtocolo.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_RESPUESTA_PROTOCOLO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<RespuestasProtocolo>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterrespuestasprotocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(RespuestasProtocolo filterrespuestasprotocolo, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_INSPECCION IDINSPECCION,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		query.append("FROM RESPUESTAS_PROTOCOLO t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterrespuestasprotocolo, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				RespuestasProtocolo.class, query, params, "ID_RESPUESTA_PROTOCOLO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical RespuestasProtocolo table.
	 *
	 * @param filterRespuestasProtocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<RespuestasProtocolo>>
	 */
	@Override
	public List<JerarquiaDto<RespuestasProtocolo>> findAllLikeJerarquia(RespuestasProtocolo filterRespuestasProtocolo,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESPUESTA_PROTOCOLO IDRESPUESTAPROTOCOLO,t1.ID_PREGUNTA_PROTOCOLO IDPREGUNTAPROTOCOLO,t1.ID_INSPECCION IDINSPECCION,t1.RESPUESTA RESPUESTA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION,t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESPUESTAS_PROTOCOLO t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESPUESTAS_PROTOCOLO");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRespuestasProtocolo, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_RESPUESTA_PROTOCOLO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					RespuestasProtocoloDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterRespuestasProtocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(RespuestasProtocolo filterRespuestasProtocolo,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESPUESTAS_PROTOCOLO t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESPUESTAS_PROTOCOLO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRespuestasProtocolo, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_RESPUESTA_PROTOCOLO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterRespuestasProtocolo
	 *            RespuestasProtocolo
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<RespuestasProtocolo>>
	 */
	@Override
	public List<TableRowDto<RespuestasProtocolo>> findAllChild(RespuestasProtocolo filterRespuestasProtocolo,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM RESPUESTAS_PROTOCOLO t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESPUESTAS_PROTOCOLO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterRespuestasProtocolo, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
				"ID_RESPUESTA_PROTOCOLO", "ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<RespuestasProtocolo>(this.rwMapPK, "ID_RESPUESTA_PROTOCOLO"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RespuestasProtocolo entity
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(RespuestasProtocolo respuestasprotocolo) {

		StringBuilder where = new StringBuilder(RespuestasProtocoloDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (respuestasprotocolo != null && respuestasprotocolo.getIdRespuestaProtocolo() != null) {
			where.append(" AND t1.ID_RESPUESTA_PROTOCOLO = ?");
			params.add(respuestasprotocolo.getIdRespuestaProtocolo());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getIdRelProPre() != null) {
			where.append(" AND t1.ID_PREGUNTA_PROTOCOLO = ?");
			params.add(respuestasprotocolo.getIdRelProPre());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getInspeccion() != null
				&& respuestasprotocolo.getInspeccion().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(respuestasprotocolo.getInspeccion().getIdInspeccion());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getRespuesta() != null) {
			where.append(" AND t1.RESPUESTA = ?");
			params.add(respuestasprotocolo.getRespuesta());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(respuestasprotocolo.getFechaRegistro());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(respuestasprotocolo.getUsuarioRegistro());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(respuestasprotocolo.getFechaUltmodificacion());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getUsuarioUltmodificacion() != null) {
			where.append(" AND t1.USUARIO_ULTMODIFICACION = ?");
			params.add(respuestasprotocolo.getUsuarioUltmodificacion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the RespuestasProtocolo entity
	 *
	 * @param respuestasprotocolo
	 *            RespuestasProtocolo Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(RespuestasProtocolo respuestasprotocolo, Boolean startsWith) {

		StringBuilder where = new StringBuilder(RespuestasProtocoloDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (respuestasprotocolo != null && respuestasprotocolo.getIdRespuestaProtocolo() != null) {
			where.append(" AND t1.ID_RESPUESTA_PROTOCOLO = ?");
			params.add(respuestasprotocolo.getIdRespuestaProtocolo());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getIdRelProPre() != null) {
			where.append(" AND t1.ID_PREGUNTA_PROTOCOLO = ?");
			params.add(respuestasprotocolo.getIdRelProPre());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getInspeccion() != null
				&& respuestasprotocolo.getInspeccion().getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(respuestasprotocolo.getInspeccion().getIdInspeccion());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getRespuesta() != null) {
			where.append(" AND UPPER(t1.RESPUESTA) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(respuestasprotocolo.getRespuesta().toUpperCase() + "%");
			} else {
				params.add("%" + respuestasprotocolo.getRespuesta().toUpperCase() + "%");
			}
			where.append(" AND t1.RESPUESTA IS NOT NULL");
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(respuestasprotocolo.getFechaRegistro());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(respuestasprotocolo.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + respuestasprotocolo.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getFechaUltmodificacion() != null) {
			where.append(" AND t1.FECHA_ULTMODIFICACION = ?");
			params.add(respuestasprotocolo.getFechaUltmodificacion());
		}
		if (respuestasprotocolo != null && respuestasprotocolo.getUsuarioUltmodificacion() != null) {
			where.append(" AND UPPER(t1.USUARIO_ULTMODIFICACION) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(respuestasprotocolo.getUsuarioUltmodificacion().toUpperCase() + "%");
			} else {
				params.add("%" + respuestasprotocolo.getUsuarioUltmodificacion().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_ULTMODIFICACION IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
